#!/usr/bin/env node
import{program as j} from"commander";import Ie from"inquirer";var U={name:"create-ev0-app",version:"0.3.1",description:"The best CLI for creating, building, and deploying your Next.js apps",license:"MIT",repository:{type:"git",url:"https://github.com/itsdrvgo/create-ev0-app.git",directory:"apps/cli"},keywords:["cli","ev0","nextjs","create-next-app","next","react","react-framework","reactjs","typescript","t3-app","t3","tailwindcss","drizzle","prisma","supabase","vercel"],type:"module",exports:"./dist/index.js",bin:{"create-ev0-app":"./dist/index.js"},files:["dist","template","LICENSE","README.md","package.json"],engines:{node:">=18.17.0"},author:{name:"itsdrvgo",url:"https://itsdrvgo.me/"},scripts:{dev:"bun run src/index.ts",build:"bun run build.ts",lint:"eslint . --ext .ts","lint:fix":"bun run lint --fix","pub:beta":"bun run build && npm publish --tag beta","pub:next":"bun run build && npm publish --tag next","pub:release":"bun run build && npm publish"},dependencies:{commander:"^12.0.0",execa:"7.1.1","gradient-string":"^2.0.2",inquirer:"^9.2.21","loading-cli":"^1.1.2",zod:"^3.23.8"},devDependencies:{"@ianvs/prettier-plugin-sort-imports":"^4.2.1","@types/bun":"latest","@types/gradient-string":"^1.1.6","@types/inquirer":"^9.0.7","@typescript-eslint/eslint-plugin":"^7.9.0","@typescript-eslint/parser":"^7.9.0",eslint:"8.57.0","eslint-config-prettier":"^9.1.0","eslint-plugin-unused-imports":"^3.2.0",prettier:"^3.2.5",typescript:"^5.4.5"},peerDependencies:{typescript:"^5.0.0"}};import $ from"path";import{fileURLToPath as pe} from"url";var oe=pe(import.meta.url),ce=$.dirname(oe),W=$.join(ce,"../"),b="ev0-app",X="ev0",Z="CREATE EV0 APP",o;(function(a){a["NPM"]="npm";a["YARN"]="yarn";a["PNPM"]="pnpm";a["BUN"]="bun"})(o||(o={}));import N from"fs";import ze from"path";import we from"gradient-string";import w from"loading-cli";import{execSync as F} from"child_process";import c from"fs";import d from"path";function B(e){return e!=="none"?{DATABASE_URL:`z
            .string()
            .url()
            .regex(
                ${e==="supabase"?/postgres/:/mongodb/}
            )
`}:{}}var S=`z
        .string()
        .min(1, "Missing UPLOADTHING_SECRET")
        .regex(/^sk_/)
`,Q=`z
        .string()
        .min(1, "Missing UPLOADTHING_APP_ID")
`,y=`z
        .string()
        .min(1, "Missing NEXT_PUBLIC_CLERK_PUBLISHABLE_KEY")
`,v=`z.string().min(1, "Missing CLERK_SECRET_KEY")
`,P=`z
        .string()
        .min(1, "Missing SVIX_SECRET")
        .regex(/^whsec_/)
`;var M={name:"drizzle",packages:{dependencies:{"drizzle-orm":"^0.30.10","drizzle-zod":"^0.5.1"},devDependencies:{"drizzle-kit":"^0.21.4","eslint-plugin-drizzle":"^0.2.3"}}},K={name:"supabase",packages:{dependencies:{"@supabase/supabase-js":"^2.39.8","@supabase/auth-helpers-nextjs":"^0.10.0"},devDependencies:{}}},p={SUPABASEAUTH:{name:"supabase-auth",packages:{dependencies:K.packages.dependencies,devDependencies:{}}},CLERK:{name:"clerk-auth",packages:{dependencies:{"@clerk/nextjs":"^5.0.6","@radix-ui/react-tabs":"^1.0.4",svix:"^1.24.0",zustand:"^4.5.2"},devDependencies:{}}},SUPABASEDB:{name:"supabase-db",packages:{dependencies:{"@paralleldrive/cuid2":"^2.2.2",...K.packages.dependencies,...M.packages.dependencies,postgres:"^3.4.3"},devDependencies:{...M.packages.devDependencies}}},MONGODB:{name:"mongodb",packages:{dependencies:{"@prisma/client":"^5.16.1"},devDependencies:{prisma:"^5.16.1"}}},TRPC:{name:"trpc",packages:{dependencies:{"@trpc/client":"next","@trpc/next":"next","@trpc/react-query":"next","@trpc/server":"next","@tanstack/react-query":"^5.28.2",superjson:"^2.2.1"},devDependencies:{"@tanstack/react-query-devtools":"^5.29.2"}}},UPLOADTHING:{name:"uploadthing",packages:{dependencies:{"@uploadthing/react":"^6.4.0",uploadthing:"^6.6.0"},devDependencies:{}}}};import{execa as h} from"execa";import be from"gradient-string";function R(){console.log(""),console.log(be("red","blue")(Z)),console.log("- "+U.version),console.log("")}function m(e){return d.join(W,e)}async function Y(e){const i=m("template/base");await u(i,e)}async function u(e,i){await c.promises.mkdir(i,{recursive:!0});const n=await c.promises.readdir(e,{withFileTypes:!0});for(let t of n){const a=d.join(e,t.name),s=d.join(i,t.name);if(t.isDirectory())await u(a,s);else{const r=await c.promises.readFile(a);await c.promises.writeFile(s,r)}}}async function de({auth:e,db:i,features:n}){let t={};if(e==="clerk")t={...t,NEXT_PUBLIC_CLERK_PUBLISHABLE_KEY:y,CLERK_SECRET_KEY:v,SVIX_SECRET:P};else if(e==="supabase")t={...t,...B("supabase")};if(i==="mongodb")t={...t,...B("mongodb")};else if(i==="supabase")t={...t,...B("supabase")};if(n.includes("uploadthing"))t={...t,UPLOADTHING_SECRET:S,UPLOADTHING_APP_ID:Q};return{keys:Object.keys(t),envs:t}}async function T({auth:e,db:i,features:n,projectPath:t}){const{envs:a}=await de({auth:e,db:i,features:n});await xe(a,t),await ge(a,t)}async function ge(e,i){if(!Object.keys(e).length)return;const n=Object.entries(e).map(([a])=>`${a}=""`).join("\n"),t=d.join(i,".env.local");await c.promises.writeFile(t,n).catch((a)=>{console.error(a)})}async function xe(e,i){if(!Object.keys(e).length)return;const n=d.join(i,"env.mjs"),t=Object.keys(e).some((s)=>s.startsWith("NEXT_PUBLIC")),a=`
import { createEnv } from "@t3-oss/env-nextjs";
import { z } from "zod";

export const env = createEnv({
    server: {
        ${Object.entries(e).filter(([s])=>!s.startsWith("NEXT_PUBLIC")).map(([s,r])=>{return`${s}: ${r},`}).join("\n")}
        NODE_ENV: z.enum(["development", "test", "production"]),
    },
    client: {
        ${t?Object.entries(e).filter(([s])=>s.startsWith("NEXT_PUBLIC")).map(([s,r])=>{return`${s}: ${r},`}).join("\n"):""}
    },
    runtimeEnv: {
        ${Object.keys(e).map((s)=>{return`${s}: process.env.${s},`}).join("\n")}
        NODE_ENV: process.env.NODE_ENV,
    },
});
    `;await c.promises.writeFile(n,a).catch((s)=>console.error(s))}function k({auth:e,db:i,features:n}){const t=[],a=[],s=[];switch(e){case"supabase":t.push("supabase-base"),a.push(p.SUPABASEAUTH.packages.dependencies),s.push(p.SUPABASEAUTH.packages.devDependencies);break;case"clerk":t.push("clerk-base"),a.push(p.CLERK.packages.dependencies),s.push(p.CLERK.packages.devDependencies);break}switch(i){case"supabase":if(t.push("supabase-base","drizzle-base"),e==="clerk")t.push("clerk-drizzle");a.push(p.SUPABASEDB.packages.dependencies),s.push(p.SUPABASEDB.packages.devDependencies);break;case"mongodb":switch(t.push("prisma-base"),e){case"clerk":t.push("clerk-prisma");break;case"supabase":t.push("supabase-base");break}a.push(p.MONGODB.packages.dependencies),s.push(p.MONGODB.packages.devDependencies);break}if(n.includes("trpc")){switch(t.push("trpc-base"),e){case"supabase":switch(t.push("supabase-auth-trpc"),i){case"supabase":t.push("supabase-db-trpc");break;case"mongodb":t.push("supabase-mongo-trpc");break}break;case"clerk":switch(t.push("clerk-trpc"),i){case"supabase":t.push("clerk-drizzle-trpc");break;case"mongodb":t.push("clerk-prisma-trpc");break}break;case"none":switch(i){case"supabase":t.push("supabase-trpc");break;case"mongodb":t.push("prisma-trpc");break}break}a.push(p.TRPC.packages.dependencies),s.push(p.TRPC.packages.devDependencies)}if(n.includes("uploadthing"))t.push("ut-base"),a.push(p.UPLOADTHING.packages.dependencies),s.push(p.UPLOADTHING.packages.devDependencies);const r=a.reduce((I,z)=>({...I,...z}),{}),l=s.reduce((I,z)=>({...I,...z}),{});return{foldersToCopy:t,dependencies:r,devDependencies:l}}async function J({projectPath:e,dependencies:i,devDependencies:n}){const t=d.join(e,"package.json"),a=JSON.parse(await c.promises.readFile(t,"utf-8"));return a.name=d.basename(e),a.dependencies={...a.dependencies,...i},a.dependencies=Object.keys(a.dependencies).sort().reduce((s,r)=>{return s[r]=a.dependencies[r],s},{}),a.devDependencies={...a.devDependencies,...n},a.devDependencies=Object.keys(a.devDependencies).sort().reduce((s,r)=>{return s[r]=a.devDependencies[r],s},{}),await c.promises.writeFile(t,JSON.stringify(a,null,2)),a}async function A(e,i){if(e.includes("trpc-base")){const n=m("template/trpc-base");await u(n,i)}}async function G(e,i){if(e.includes("ut-base")){const n=m("template/ut-base");await u(n,i)}}async function C(e,i){if(e.includes("supabase-base")){const n=m("template/supabase-base");await u(n,i)}if(e.includes("supabase-auth-trpc")){const n=m("template/supabase-auth-trpc");await u(n,i)}if(e.includes("supabase-db-trpc")){const n=m("template/supabase-db-trpc");await u(n,i)}}async function ee(e,i){if(e.includes("clerk-base")){const n=m("template/clerk-base");await u(n,i)}if(e.includes("clerk-trpc")){const n=m("template/clerk-trpc");await u(n,i)}if(e.includes("clerk-drizzle")){const n=m("template/clerk-drizzle");await u(n,i)}if(e.includes("clerk-drizzle-trpc")){const n=m("template/clerk-drizzle-trpc");await u(n,i)}}async function ie(e,i,n){if(e.includes("prisma-base")){const t=m("template/prisma-base");await u(t,i),n.scripts={...n.scripts,postinstall:"prisma generate --schema=./src/lib/prisma/schema.prisma","db:push":"prisma db push","db:introspect":"prisma db pull","db:studio":"prisma studio"},await c.promises.writeFile(d.join(i,"package.json"),JSON.stringify(n,null,2))}if(e.includes("clerk-prisma")){const t=m("template/clerk-prisma");await u(t,i)}if(e.includes("prisma-trpc")){const t=m("template/prisma-trpc");await u(t,i)}if(e.includes("clerk-prisma-trpc")){const t=m("template/clerk-prisma-trpc");await u(t,i)}if(e.includes("supabase-mongo-trpc")){const t=m("template/supabase-mongo-trpc");await u(t,i)}}async function te(e,i,n){if(e.includes("drizzle-base")){const t=m("template/drizzle-base");await u(t,i),n.scripts={...n.scripts,postinstall:"drizzle-kit generate","db:push":"drizzle-kit push","db:introspect":"drizzle-kit introspect","db:studio":"drizzle-kit studio"},await c.promises.writeFile(d.join(i,"package.json"),JSON.stringify(n,null,2))}}function ne(){try{return F("bun --version",{stdio:"ignore"}),o.BUN}catch(e){try{return F("pnpm --version",{stdio:"ignore"}),o.PNPM}catch(i){try{return F("yarn --version",{stdio:"ignore"}),o.YARN}catch(n){return o.NPM}}}}async function ae({packageManager:e,projectPath:i}){switch(e){case o.NPM:await h(e,["install"],{cwd:i,stderr:"inherit"});break;case o.YARN:await h(e,["install"],{cwd:i,stdout:"pipe"});break;case o.PNPM:await h(e,["install"],{cwd:i,stdout:"pipe"});break;case o.BUN:await h(e,["install"],{cwd:i,stdout:"inherit"});break}}function fe(){try{return F("git --version",{stdio:"ignore"}),!0}catch(e){return!1}}async function se(e){if(!fe())throw new Error("Git is not installed!",{cause:"GIT_NOT_INSTALLED"});await h("git",["init"],{cwd:e,stdout:"ignore"})}async function re(e=b){const i=w("Creating project, please wait until it's done...").start(),n=process.cwd()+"/"+e;N.mkdirSync(n),await Y(n),i.succeed(`Project created successfully! Run 'cd ${e}' to start working on your project.`)}async function O({name:e,auth:i,db:n,features:t,install:a,git:s}){const r=w("Creating project folder...").start(),l=ze.join(process.cwd(),e);if(N.existsSync(l)){r.fail("A project with the same name already exists!");return}N.mkdirSync(l),r.succeed("Project folder created successfully!");const z=w("Inserting base files...").start(),{foldersToCopy:x,dependencies:E,devDependencies:q}=k({auth:i,db:n,features:t});await Y(l),z.succeed("Base files inserted successfully!");const H=w("Writing dependencies...").start(),V=await J({projectPath:l,dependencies:E,devDependencies:q});H.succeed("Dependencies written successfully!");const ue=w("Inserting files...").start();if(await A(x,l),await G(x,l),await C(x,l),await ee(x,l),await te(x,l,V),await ie(x,l,V),await T({auth:i,db:n,features:t,projectPath:l}),ue.succeed("Files inserted successfully!"),s){const D=w("Initializing git repository...").start();try{await se(l),D.succeed("Git repository initialized successfully!")}catch(L){if(L instanceof Error)if(L.cause==="GIT_NOT_INSTALLED"){D.fail("Git is not installed on your system!");return}else{D.fail("An error occurred while initializing git repository!");return}}}if(a){const D=w("Installing dependencies...").start(),L=ne();await ae({packageManager:L,projectPath:l}),D.succeed("Dependencies installed successfully!")}console.info(`${we("blue","blue")(">")} Project created successfully! Run 'cd ${e}' to start working on your project.`)}import{z as f} from"zod";var _=f.object({name:f.string().min(1,"Name must be at least 1 character").default(b),auth:f.enum(["supabase","clerk","none"]).default("supabase"),db:f.enum(["supabase","mongodb","none"]).default("supabase"),features:f.array(f.enum(["trpc","uploadthing"])).default([]),git:f.boolean().default(!0),install:f.boolean().default(!0)});import{z as g} from"zod";var le=g.object({default:g.boolean().optional(),empty:g.boolean().optional(),name:_.shape.name.optional(),supabaseAuth:g.boolean().optional(),clerk:g.boolean().optional(),supabaseDb:g.boolean().optional(),mongodb:g.boolean().optional(),trpc:g.boolean().optional(),uploadthing:g.boolean().optional()}).refine((e)=>!(e.supabaseAuth&&e.clerk),"You can't use both Supabase and Clerk as authentication providers at the same time").refine((e)=>!(e.supabaseDb&&e.mongodb),"You can't use both Supabase and MongoDB as database providers at the same time");j.name(X).description("The best stack for a Full Stack Web Developer").version(U.version).option("-d, --default","use default options").option("-e, --empty","create an empty project").option("-n, --name <name>","project name").option("-sba, --supabase-auth","use Supabase (Auth)").option("-cla, --clerk","use Clerk (Auth)").option("-sbdb, --supabase-db","use Supabase (Database)").option("-mongo, --mongodb","use MongoDB").option("-trpc, --trpc","use tRPC").option("-ut, --uploadthing","use UploadThing (File Uploads)").action(async(e)=>{if(R(),Object.keys(e).length===0)return j.help();const{data:n,error:t}=le.safeParse(e);if(t)return console.error(t.issues.map((H)=>H.message).join("\n"));const{default:a,empty:s,name:r,supabaseAuth:l,clerk:I,supabaseDb:z,mongodb:x,trpc:E,uploadthing:q}=n;if(a){if(Object.keys(e).length>1){console.error("You can't use --default flag with other flags");return}await O({name:b,auth:"supabase",db:"supabase",features:[],git:!0,install:!0});return}if(s){await re(r||b);return}await O({name:r||b,auth:l?"supabase":I?"clerk":"none",db:z?"supabase":x?"mongodb":"none",features:[...E?["trpc"]:[],...q?["uploadthing"]:[]],git:!0,install:!0})});j.command("init").description("Initialize a new project").action(async()=>{R();const e=await Ie.prompt([{type:"input",name:"name",message:"Project name:",default:b},{type:"list",name:"auth",message:"Choose your authentication provider:",choices:[{name:"Supabase",value:"supabase"},{name:"Clerk",value:"clerk"},{name:"None",value:"none"}],default:"supabase"},{type:"list",name:"db",message:"Choose your database provider:",choices:[{name:"Supabase (Postgres)",value:"supabase"},{name:"MongoDB",value:"mongodb"},{name:"None",value:"none"}],default:"supabase"},{type:"checkbox",name:"features",message:"Select additional features:",choices:[{name:"tRPC",value:"trpc"},{name:"UploadThing (File Uploads)",value:"uploadthing"}],default:["tailwind","shadcn"]},{type:"confirm",name:"git",message:"Initialize a git repository?",default:!0},{type:"confirm",name:"install",message:"Install dependencies?",default:!0}]),i=_.parse(e);await O({name:i.name,auth:i.auth,db:i.db,features:i.features,git:i.git,install:i.install})});j.parse(process.argv);
